<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CouponCodeSearchBasic StructType
 * @subpackage Structs
 */
class CouponCodeSearchBasic extends SearchRecordBasic
{
    /**
     * The code
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\SearchStringField
     */
    public $code;
    /**
     * The dateSent
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\SearchDateField
     */
    public $dateSent;
    /**
     * The externalId
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\SearchMultiSelectField
     */
    public $externalId;
    /**
     * The externalIdString
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\SearchStringField
     */
    public $externalIdString;
    /**
     * The id
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\SearchLongField
     */
    public $id;
    /**
     * The internalId
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\SearchMultiSelectField
     */
    public $internalId;
    /**
     * The internalIdNumber
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\SearchLongField
     */
    public $internalIdNumber;
    /**
     * The promotion
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\SearchMultiSelectField
     */
    public $promotion;
    /**
     * The recipient
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\SearchMultiSelectField
     */
    public $recipient;
    /**
     * The useCount
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\SearchLongField
     */
    public $useCount;
    /**
     * The used
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\SearchBooleanField
     */
    public $used;
    /**
     * Constructor method for CouponCodeSearchBasic
     * @uses CouponCodeSearchBasic::setCode()
     * @uses CouponCodeSearchBasic::setDateSent()
     * @uses CouponCodeSearchBasic::setExternalId()
     * @uses CouponCodeSearchBasic::setExternalIdString()
     * @uses CouponCodeSearchBasic::setId()
     * @uses CouponCodeSearchBasic::setInternalId()
     * @uses CouponCodeSearchBasic::setInternalIdNumber()
     * @uses CouponCodeSearchBasic::setPromotion()
     * @uses CouponCodeSearchBasic::setRecipient()
     * @uses CouponCodeSearchBasic::setUseCount()
     * @uses CouponCodeSearchBasic::setUsed()
     * @param \StructType\SearchStringField $code
     * @param \StructType\SearchDateField $dateSent
     * @param \StructType\SearchMultiSelectField $externalId
     * @param \StructType\SearchStringField $externalIdString
     * @param \StructType\SearchLongField $id
     * @param \StructType\SearchMultiSelectField $internalId
     * @param \StructType\SearchLongField $internalIdNumber
     * @param \StructType\SearchMultiSelectField $promotion
     * @param \StructType\SearchMultiSelectField $recipient
     * @param \StructType\SearchLongField $useCount
     * @param \StructType\SearchBooleanField $used
     */
    public function __construct(\StructType\SearchStringField $code = null, \StructType\SearchDateField $dateSent = null, \StructType\SearchMultiSelectField $externalId = null, \StructType\SearchStringField $externalIdString = null, \StructType\SearchLongField $id = null, \StructType\SearchMultiSelectField $internalId = null, \StructType\SearchLongField $internalIdNumber = null, \StructType\SearchMultiSelectField $promotion = null, \StructType\SearchMultiSelectField $recipient = null, \StructType\SearchLongField $useCount = null, \StructType\SearchBooleanField $used = null)
    {
        $this
            ->setCode($code)
            ->setDateSent($dateSent)
            ->setExternalId($externalId)
            ->setExternalIdString($externalIdString)
            ->setId($id)
            ->setInternalId($internalId)
            ->setInternalIdNumber($internalIdNumber)
            ->setPromotion($promotion)
            ->setRecipient($recipient)
            ->setUseCount($useCount)
            ->setUsed($used);
    }
    /**
     * Get code value
     * @return \StructType\SearchStringField|null
     */
    public function getCode()
    {
        return $this->code;
    }
    /**
     * Set code value
     * @param \StructType\SearchStringField $code
     * @return \StructType\CouponCodeSearchBasic
     */
    public function setCode(\StructType\SearchStringField $code = null)
    {
        $this->code = $code;
        return $this;
    }
    /**
     * Get dateSent value
     * @return \StructType\SearchDateField|null
     */
    public function getDateSent()
    {
        return $this->dateSent;
    }
    /**
     * Set dateSent value
     * @param \StructType\SearchDateField $dateSent
     * @return \StructType\CouponCodeSearchBasic
     */
    public function setDateSent(\StructType\SearchDateField $dateSent = null)
    {
        $this->dateSent = $dateSent;
        return $this;
    }
    /**
     * Get externalId value
     * @return \StructType\SearchMultiSelectField|null
     */
    public function getExternalId()
    {
        return $this->externalId;
    }
    /**
     * Set externalId value
     * @param \StructType\SearchMultiSelectField $externalId
     * @return \StructType\CouponCodeSearchBasic
     */
    public function setExternalId(\StructType\SearchMultiSelectField $externalId = null)
    {
        $this->externalId = $externalId;
        return $this;
    }
    /**
     * Get externalIdString value
     * @return \StructType\SearchStringField|null
     */
    public function getExternalIdString()
    {
        return $this->externalIdString;
    }
    /**
     * Set externalIdString value
     * @param \StructType\SearchStringField $externalIdString
     * @return \StructType\CouponCodeSearchBasic
     */
    public function setExternalIdString(\StructType\SearchStringField $externalIdString = null)
    {
        $this->externalIdString = $externalIdString;
        return $this;
    }
    /**
     * Get id value
     * @return \StructType\SearchLongField|null
     */
    public function getId()
    {
        return $this->id;
    }
    /**
     * Set id value
     * @param \StructType\SearchLongField $id
     * @return \StructType\CouponCodeSearchBasic
     */
    public function setId(\StructType\SearchLongField $id = null)
    {
        $this->id = $id;
        return $this;
    }
    /**
     * Get internalId value
     * @return \StructType\SearchMultiSelectField|null
     */
    public function getInternalId()
    {
        return $this->internalId;
    }
    /**
     * Set internalId value
     * @param \StructType\SearchMultiSelectField $internalId
     * @return \StructType\CouponCodeSearchBasic
     */
    public function setInternalId(\StructType\SearchMultiSelectField $internalId = null)
    {
        $this->internalId = $internalId;
        return $this;
    }
    /**
     * Get internalIdNumber value
     * @return \StructType\SearchLongField|null
     */
    public function getInternalIdNumber()
    {
        return $this->internalIdNumber;
    }
    /**
     * Set internalIdNumber value
     * @param \StructType\SearchLongField $internalIdNumber
     * @return \StructType\CouponCodeSearchBasic
     */
    public function setInternalIdNumber(\StructType\SearchLongField $internalIdNumber = null)
    {
        $this->internalIdNumber = $internalIdNumber;
        return $this;
    }
    /**
     * Get promotion value
     * @return \StructType\SearchMultiSelectField|null
     */
    public function getPromotion()
    {
        return $this->promotion;
    }
    /**
     * Set promotion value
     * @param \StructType\SearchMultiSelectField $promotion
     * @return \StructType\CouponCodeSearchBasic
     */
    public function setPromotion(\StructType\SearchMultiSelectField $promotion = null)
    {
        $this->promotion = $promotion;
        return $this;
    }
    /**
     * Get recipient value
     * @return \StructType\SearchMultiSelectField|null
     */
    public function getRecipient()
    {
        return $this->recipient;
    }
    /**
     * Set recipient value
     * @param \StructType\SearchMultiSelectField $recipient
     * @return \StructType\CouponCodeSearchBasic
     */
    public function setRecipient(\StructType\SearchMultiSelectField $recipient = null)
    {
        $this->recipient = $recipient;
        return $this;
    }
    /**
     * Get useCount value
     * @return \StructType\SearchLongField|null
     */
    public function getUseCount()
    {
        return $this->useCount;
    }
    /**
     * Set useCount value
     * @param \StructType\SearchLongField $useCount
     * @return \StructType\CouponCodeSearchBasic
     */
    public function setUseCount(\StructType\SearchLongField $useCount = null)
    {
        $this->useCount = $useCount;
        return $this;
    }
    /**
     * Get used value
     * @return \StructType\SearchBooleanField|null
     */
    public function getUsed()
    {
        return $this->used;
    }
    /**
     * Set used value
     * @param \StructType\SearchBooleanField $used
     * @return \StructType\CouponCodeSearchBasic
     */
    public function setUsed(\StructType\SearchBooleanField $used = null)
    {
        $this->used = $used;
        return $this;
    }
}
